=== modified file 'lib/lp/bugs/browser/tests/test_bugtask.py'
--- lib/lp/bugs/browser/tests/test_bugtask.py	2011-12-20 04:38:42 +0000
+++ lib/lp/bugs/browser/tests/test_bugtask.py	2011-12-22 11:40:58 +0000
@@ -94,9 +94,6 @@
 from lp.testing.views import create_initialized_view
 
 
-DELETE_BUGTASK_ENABLED = {u"disclosure.delete_bugtask.enabled": u"on"}
-
-
 class TestBugTaskView(TestCaseWithFactory):
 
     layer = LaunchpadFunctionalLayer
@@ -186,7 +183,7 @@
         self.invalidate_caches(bug.default_bugtask)
         self.getUserBrowser(url, owner)
         # At least 20 of these should be removed.
-        self.assertThat(recorder, HasQueryCount(LessThan(101)))
+        self.assertThat(recorder, HasQueryCount(LessThan(106)))
         count_with_no_branches = recorder.count
         for sp in sourcepackages:
             self.makeLinkedBranchMergeProposal(sp, bug, owner)
@@ -782,8 +779,7 @@
         row_view = view._getTableRowView(bug.default_bugtask, False, False)
         self.assertFalse(row_view.user_can_delete_bugtask)
         del get_property_cache(row_view).user_can_delete_bugtask
-        with FeatureFixture(DELETE_BUGTASK_ENABLED):
-            self.assertFalse(row_view.user_can_delete_bugtask)
+        self.assertFalse(row_view.user_can_delete_bugtask)
 
     def test_can_delete_bugtask_if_authorised(self):
         # The bugtask can be deleted if the user if authorised.
@@ -794,11 +790,7 @@
             bug, name='+bugtasks-and-nominations-table',
             principal=bugtask.owner)
         row_view = view._getTableRowView(bugtask, False, False)
-        self.assertFalse(row_view.user_can_delete_bugtask)
-        del get_property_cache(row_view).user_can_delete_bugtask
-        clear_cache()
-        with FeatureFixture(DELETE_BUGTASK_ENABLED):
-            self.assertTrue(row_view.user_can_delete_bugtask)
+        self.assertTrue(row_view.user_can_delete_bugtask)
 
     def test_bugtask_delete_icon(self):
         # The bugtask delete icon is rendered correctly for those tasks the
@@ -806,28 +798,27 @@
         bug = self.factory.makeBug()
         bugtask_owner = self.factory.makePerson()
         bugtask = self.factory.makeBugTask(bug=bug, owner=bugtask_owner)
-        with FeatureFixture(DELETE_BUGTASK_ENABLED):
-            login_person(bugtask.owner)
-            getUtility(ILaunchBag).add(bug.default_bugtask)
-            view = create_initialized_view(
-                bug, name='+bugtasks-and-nominations-table',
-                principal=bugtask.owner)
-            # We render the bug task table rows - there are 2 bug tasks.
-            subviews = view.getBugTaskAndNominationViews()
-            self.assertEqual(2, len(subviews))
-            default_bugtask_contents = subviews[0]()
-            bugtask_contents = subviews[1]()
-            # bugtask can be deleted because the user owns it.
-            delete_icon = find_tag_by_id(
-                bugtask_contents, 'bugtask-delete-task%d' % bugtask.id)
-            delete_url = canonical_url(
-                bugtask, rootsite='bugs', view_name='+delete')
-            self.assertEqual(delete_url, delete_icon['href'])
-            # default_bugtask cannot be deleted.
-            delete_icon = find_tag_by_id(
-                default_bugtask_contents,
-                'bugtask-delete-task%d' % bug.default_bugtask.id)
-            self.assertIsNone(delete_icon)
+        login_person(bugtask.owner)
+        getUtility(ILaunchBag).add(bug.default_bugtask)
+        view = create_initialized_view(
+            bug, name='+bugtasks-and-nominations-table',
+            principal=bugtask.owner)
+        # We render the bug task table rows - there are 2 bug tasks.
+        subviews = view.getBugTaskAndNominationViews()
+        self.assertEqual(2, len(subviews))
+        default_bugtask_contents = subviews[0]()
+        bugtask_contents = subviews[1]()
+        # bugtask can be deleted because the user owns it.
+        delete_icon = find_tag_by_id(
+            bugtask_contents, 'bugtask-delete-task%d' % bugtask.id)
+        delete_url = canonical_url(
+            bugtask, rootsite='bugs', view_name='+delete')
+        self.assertEqual(delete_url, delete_icon['href'])
+        # default_bugtask cannot be deleted.
+        delete_icon = find_tag_by_id(
+            default_bugtask_contents,
+            'bugtask-delete-task%d' % bug.default_bugtask.id)
+        self.assertIsNone(delete_icon)
 
     def test_client_cache_contents(self):
         """ Test that the client cache contains the expected data.
@@ -838,27 +829,26 @@
         bug = self.factory.makeBug()
         bugtask_owner = self.factory.makePerson()
         bugtask = self.factory.makeBugTask(bug=bug, owner=bugtask_owner)
-        with FeatureFixture(DELETE_BUGTASK_ENABLED):
-            login_person(bugtask.owner)
-            getUtility(ILaunchBag).add(bug.default_bugtask)
-            view = create_initialized_view(
-                bug, name='+bugtasks-and-nominations-table',
-                principal=bugtask.owner)
-            view.render()
-            cache = IJSONRequestCache(view.request)
-            all_bugtask_data = cache.objects['bugtask_data']
-
-            def check_bugtask_data(bugtask, can_delete):
-                self.assertIn(bugtask.id, all_bugtask_data)
-                bugtask_data = all_bugtask_data[bugtask.id]
-                self.assertEqual(
-                    'task%d' % bugtask.id, bugtask_data['form_row_id'])
-                self.assertEqual(
-                    'tasksummary%d' % bugtask.id, bugtask_data['row_id'])
-                self.assertEqual(can_delete, bugtask_data['user_can_delete'])
-
-            check_bugtask_data(bug.default_bugtask, False)
-            check_bugtask_data(bugtask, True)
+        login_person(bugtask.owner)
+        getUtility(ILaunchBag).add(bug.default_bugtask)
+        view = create_initialized_view(
+            bug, name='+bugtasks-and-nominations-table',
+            principal=bugtask.owner)
+        view.render()
+        cache = IJSONRequestCache(view.request)
+        all_bugtask_data = cache.objects['bugtask_data']
+
+        def check_bugtask_data(bugtask, can_delete):
+            self.assertIn(bugtask.id, all_bugtask_data)
+            bugtask_data = all_bugtask_data[bugtask.id]
+            self.assertEqual(
+                'task%d' % bugtask.id, bugtask_data['form_row_id'])
+            self.assertEqual(
+                'tasksummary%d' % bugtask.id, bugtask_data['row_id'])
+            self.assertEqual(can_delete, bugtask_data['user_can_delete'])
+
+        check_bugtask_data(bug.default_bugtask, False)
+        check_bugtask_data(bugtask, True)
 
 
 class TestBugTaskDeleteView(TestCaseWithFactory):
@@ -876,16 +866,15 @@
         server_url = canonical_url(
             getUtility(ILaunchpadRoot), rootsite='bugs')
         extra = {'HTTP_REFERER': bug_url}
-        with FeatureFixture(DELETE_BUGTASK_ENABLED):
-            login_person(bugtask.owner)
-            view = create_initialized_view(
-                bugtask, name='+delete', principal=bugtask.owner,
-                server_url=server_url, **extra)
-            contents = view.render()
-            confirmation_message = find_tag_by_id(
-                contents, 'confirmation-message')
-            self.assertIsNotNone(confirmation_message)
-            self.assertEqual(bug_url, view.cancel_url)
+        login_person(bugtask.owner)
+        view = create_initialized_view(
+            bugtask, name='+delete', principal=bugtask.owner,
+            server_url=server_url, **extra)
+        contents = view.render()
+        confirmation_message = find_tag_by_id(
+            contents, 'confirmation-message')
+        self.assertIsNotNone(confirmation_message)
+        self.assertEqual(bug_url, view.cancel_url)
 
     def test_delete_action(self):
         # Test that the delete action works as expected.
@@ -893,42 +882,40 @@
         bugtask = self.factory.makeBugTask(bug=bug)
         bugtask_url = canonical_url(bugtask, rootsite='bugs')
         target_name = bugtask.bugtargetdisplayname
-        with FeatureFixture(DELETE_BUGTASK_ENABLED):
-            login_person(bugtask.owner)
-            form = {
-                'field.actions.delete_bugtask': 'Delete',
-                }
-            extra = {
-                'HTTP_REFERER': bugtask_url,
-                }
-            server_url = canonical_url(
-                getUtility(ILaunchpadRoot), rootsite='bugs')
-            view = create_initialized_view(
-                bugtask, name='+delete', form=form, server_url=server_url,
-                principal=bugtask.owner, **extra)
-            self.assertEqual([bug.default_bugtask], bug.bugtasks)
-            notifications = view.request.response.notifications
-            self.assertEqual(1, len(notifications))
-            expected = 'This bug no longer affects %s.' % target_name
-            self.assertEqual(expected, notifications[0].message)
+        login_person(bugtask.owner)
+        form = {
+            'field.actions.delete_bugtask': 'Delete',
+            }
+        extra = {
+            'HTTP_REFERER': bugtask_url,
+            }
+        server_url = canonical_url(
+            getUtility(ILaunchpadRoot), rootsite='bugs')
+        view = create_initialized_view(
+            bugtask, name='+delete', form=form, server_url=server_url,
+            principal=bugtask.owner, **extra)
+        self.assertEqual([bug.default_bugtask], bug.bugtasks)
+        notifications = view.request.response.notifications
+        self.assertEqual(1, len(notifications))
+        expected = 'This bug no longer affects %s.' % target_name
+        self.assertEqual(expected, notifications[0].message)
 
     def test_delete_only_bugtask(self):
         # Test that the deleting the only bugtask results in an error message.
         bug = self.factory.makeBug()
-        with FeatureFixture(DELETE_BUGTASK_ENABLED):
-            login_person(bug.owner)
-            form = {
-                'field.actions.delete_bugtask': 'Delete',
-                }
-            view = create_initialized_view(
-                bug.default_bugtask, name='+delete', form=form,
-                principal=bug.owner)
-            self.assertEqual([bug.default_bugtask], bug.bugtasks)
-            notifications = view.request.response.notifications
-            self.assertEqual(1, len(notifications))
-            expected = ('Cannot delete only bugtask affecting: %s.'
-                % bug.default_bugtask.target.bugtargetdisplayname)
-            self.assertEqual(expected, notifications[0].message)
+        login_person(bug.owner)
+        form = {
+            'field.actions.delete_bugtask': 'Delete',
+            }
+        view = create_initialized_view(
+            bug.default_bugtask, name='+delete', form=form,
+            principal=bug.owner)
+        self.assertEqual([bug.default_bugtask], bug.bugtasks)
+        notifications = view.request.response.notifications
+        self.assertEqual(1, len(notifications))
+        expected = ('Cannot delete only bugtask affecting: %s.'
+            % bug.default_bugtask.target.bugtargetdisplayname)
+        self.assertEqual(expected, notifications[0].message)
 
     def _create_bugtask_to_delete(self):
         bug = self.factory.makeBug()
@@ -942,66 +929,64 @@
         # containing the URL of the bug's default task to redirect to.
         bug, bugtask, target_name, bugtask_url = (
             self._create_bugtask_to_delete())
-        with FeatureFixture(DELETE_BUGTASK_ENABLED):
-            login_person(bugtask.owner)
-            # Set up the request so that we correctly simulate an XHR call
-            # from the URL of the bugtask we are deleting.
-            server_url = canonical_url(
-                getUtility(ILaunchpadRoot), rootsite='bugs')
-            extra = {
-                'HTTP_X_REQUESTED_WITH': 'XMLHttpRequest',
-                'HTTP_REFERER': bugtask_url,
-                }
-            form = {
-                'field.actions.delete_bugtask': 'Delete'
-                }
-            view = create_initialized_view(
-                bugtask, name='+delete', server_url=server_url, form=form,
-                principal=bugtask.owner, **extra)
-            result_data = simplejson.loads(view.render())
-            self.assertEqual([bug.default_bugtask], bug.bugtasks)
-            notifications = simplejson.loads(
-                view.request.response.getHeader('X-Lazr-Notifications'))
-            self.assertEqual(1, len(notifications))
-            expected = 'This bug no longer affects %s.' % target_name
-            self.assertEqual(expected, notifications[0][1])
-            self.assertEqual(
-                'application/json',
-                view.request.response.getHeader('content-type'))
-            expected_url = canonical_url(bug.default_bugtask, rootsite='bugs')
-            self.assertEqual(dict(bugtask_url=expected_url), result_data)
+        login_person(bugtask.owner)
+        # Set up the request so that we correctly simulate an XHR call
+        # from the URL of the bugtask we are deleting.
+        server_url = canonical_url(
+            getUtility(ILaunchpadRoot), rootsite='bugs')
+        extra = {
+            'HTTP_X_REQUESTED_WITH': 'XMLHttpRequest',
+            'HTTP_REFERER': bugtask_url,
+            }
+        form = {
+            'field.actions.delete_bugtask': 'Delete'
+            }
+        view = create_initialized_view(
+            bugtask, name='+delete', server_url=server_url, form=form,
+            principal=bugtask.owner, **extra)
+        result_data = simplejson.loads(view.render())
+        self.assertEqual([bug.default_bugtask], bug.bugtasks)
+        notifications = simplejson.loads(
+            view.request.response.getHeader('X-Lazr-Notifications'))
+        self.assertEqual(1, len(notifications))
+        expected = 'This bug no longer affects %s.' % target_name
+        self.assertEqual(expected, notifications[0][1])
+        self.assertEqual(
+            'application/json',
+            view.request.response.getHeader('content-type'))
+        expected_url = canonical_url(bug.default_bugtask, rootsite='bugs')
+        self.assertEqual(dict(bugtask_url=expected_url), result_data)
 
     def test_ajax_delete_only_bugtask(self):
         # Test that deleting the only bugtask returns an empty JSON response
         # with an error notification.
         bug = self.factory.makeBug()
-        with FeatureFixture(DELETE_BUGTASK_ENABLED):
-            login_person(bug.owner)
-            # Set up the request so that we correctly simulate an XHR call
-            # from the URL of the bugtask we are deleting.
-            server_url = canonical_url(
-                getUtility(ILaunchpadRoot), rootsite='bugs')
-            extra = {
-                'HTTP_X_REQUESTED_WITH': 'XMLHttpRequest',
-                }
-            form = {
-                'field.actions.delete_bugtask': 'Delete'
-                }
-            view = create_initialized_view(
-                bug.default_bugtask, name='+delete', server_url=server_url,
-                form=form, principal=bug.owner, **extra)
-            result_data = simplejson.loads(view.render())
-            self.assertEqual([bug.default_bugtask], bug.bugtasks)
-            notifications = simplejson.loads(
-                view.request.response.getHeader('X-Lazr-Notifications'))
-            self.assertEqual(1, len(notifications))
-            expected = ('Cannot delete only bugtask affecting: %s.'
-                % bug.default_bugtask.target.bugtargetdisplayname)
-            self.assertEqual(expected, notifications[0][1])
-            self.assertEqual(
-                'application/json',
-                view.request.response.getHeader('content-type'))
-            self.assertEqual(None, result_data)
+        login_person(bug.owner)
+        # Set up the request so that we correctly simulate an XHR call
+        # from the URL of the bugtask we are deleting.
+        server_url = canonical_url(
+            getUtility(ILaunchpadRoot), rootsite='bugs')
+        extra = {
+            'HTTP_X_REQUESTED_WITH': 'XMLHttpRequest',
+            }
+        form = {
+            'field.actions.delete_bugtask': 'Delete'
+            }
+        view = create_initialized_view(
+            bug.default_bugtask, name='+delete', server_url=server_url,
+            form=form, principal=bug.owner, **extra)
+        result_data = simplejson.loads(view.render())
+        self.assertEqual([bug.default_bugtask], bug.bugtasks)
+        notifications = simplejson.loads(
+            view.request.response.getHeader('X-Lazr-Notifications'))
+        self.assertEqual(1, len(notifications))
+        expected = ('Cannot delete only bugtask affecting: %s.'
+            % bug.default_bugtask.target.bugtargetdisplayname)
+        self.assertEqual(expected, notifications[0][1])
+        self.assertEqual(
+            'application/json',
+            view.request.response.getHeader('content-type'))
+        self.assertEqual(None, result_data)
 
     def test_ajax_delete_non_current_bugtask(self):
         # Test that deleting the non-current bugtask returns the new bugtasks
@@ -1010,37 +995,36 @@
             self._create_bugtask_to_delete())
         default_bugtask_url = canonical_url(
             bug.default_bugtask, rootsite='bugs')
-        with FeatureFixture(DELETE_BUGTASK_ENABLED):
-            login_person(bugtask.owner)
-            # Set up the request so that we correctly simulate an XHR call
-            # from the URL of the default bugtask, not the one we are
-            # deleting.
-            server_url = canonical_url(
-                getUtility(ILaunchpadRoot), rootsite='bugs')
-            extra = {
-                'HTTP_X_REQUESTED_WITH': 'XMLHttpRequest',
-                'HTTP_REFERER': default_bugtask_url,
-                }
-            form = {
-                'field.actions.delete_bugtask': 'Delete'
-                }
-            view = create_initialized_view(
-                bugtask, name='+delete', server_url=server_url, form=form,
-                principal=bugtask.owner, **extra)
-            result_html = view.render()
-            self.assertEqual([bug.default_bugtask], bug.bugtasks)
-            notifications = view.request.response.notifications
-            self.assertEqual(1, len(notifications))
-            expected = 'This bug no longer affects %s.' % target_name
-            self.assertEqual(expected, notifications[0].message)
-            self.assertEqual(
-                view.request.response.getHeader('content-type'), 'text/html')
-            table = find_tag_by_id(result_html, 'affected-software')
-            self.assertIsNotNone(table)
-            [row] = table.tbody.findAll('tr', {'class': 'highlight'})
-            target_link = row.find('a', {'class': 'sprite product'})
-            self.assertIn(
-                bug.default_bugtask.bugtargetdisplayname, target_link)
+        login_person(bugtask.owner)
+        # Set up the request so that we correctly simulate an XHR call
+        # from the URL of the default bugtask, not the one we are
+        # deleting.
+        server_url = canonical_url(
+            getUtility(ILaunchpadRoot), rootsite='bugs')
+        extra = {
+            'HTTP_X_REQUESTED_WITH': 'XMLHttpRequest',
+            'HTTP_REFERER': default_bugtask_url,
+            }
+        form = {
+            'field.actions.delete_bugtask': 'Delete'
+            }
+        view = create_initialized_view(
+            bugtask, name='+delete', server_url=server_url, form=form,
+            principal=bugtask.owner, **extra)
+        result_html = view.render()
+        self.assertEqual([bug.default_bugtask], bug.bugtasks)
+        notifications = view.request.response.notifications
+        self.assertEqual(1, len(notifications))
+        expected = 'This bug no longer affects %s.' % target_name
+        self.assertEqual(expected, notifications[0].message)
+        self.assertEqual(
+            view.request.response.getHeader('content-type'), 'text/html')
+        table = find_tag_by_id(result_html, 'affected-software')
+        self.assertIsNotNone(table)
+        [row] = table.tbody.findAll('tr', {'class': 'highlight'})
+        target_link = row.find('a', {'class': 'sprite product'})
+        self.assertIn(
+            bug.default_bugtask.bugtargetdisplayname, target_link)
 
 
 class TestBugTasksAndNominationsViewAlsoAffects(TestCaseWithFactory):

=== modified file 'lib/lp/bugs/browser/tests/test_bugtask_navigation.py'
--- lib/lp/bugs/browser/tests/test_bugtask_navigation.py	2011-12-19 09:53:25 +0000
+++ lib/lp/bugs/browser/tests/test_bugtask_navigation.py	2011-12-22 05:56:59 +0000
@@ -10,7 +10,6 @@
 
 from canonical.launchpad.webapp.publisher import canonical_url
 from canonical.testing.layers import DatabaseFunctionalLayer
-from lp.services.features.testing import FeatureFixture
 from lp.testing import (
     login_person,
     TestCaseWithFactory,
@@ -28,10 +27,8 @@
         bug = self.factory.makeBug()
         bugtask = self.factory.makeBugTask(bug=bug)
         bugtask_url = canonical_url(bugtask, rootsite='bugs')
-        flags = {u"disclosure.delete_bugtask.enabled": u"on"}
         login_person(bugtask.owner)
-        with FeatureFixture(flags):
-            bugtask.delete()
+        bugtask.delete()
         obj, view, request = test_traverse(bugtask_url)
         view()
         naked_view = removeSecurityProxy(view)
@@ -47,8 +44,6 @@
         bugtask = self.factory.makeBugTask(bug=bug)
         bugtask_delete_url = canonical_url(
             bugtask, rootsite='bugs', view_name='+delete')
-        flags = {u"disclosure.delete_bugtask.enabled": u"on"}
         login_person(bugtask.owner)
-        with FeatureFixture(flags):
-            bugtask.delete()
+        bugtask.delete()
         self.assertRaises(NotFound, test_traverse, bugtask_delete_url)

=== modified file 'lib/lp/bugs/mail/tests/test_bug_task_deletion.py'
--- lib/lp/bugs/mail/tests/test_bug_task_deletion.py	2011-12-19 23:38:16 +0000
+++ lib/lp/bugs/mail/tests/test_bug_task_deletion.py	2011-12-22 05:56:59 +0000
@@ -10,7 +10,6 @@
 from canonical.testing.layers import DatabaseFunctionalLayer
 from lp.bugs.model.bugnotification import BugNotification
 from lp.bugs.scripts.bugnotification import construct_email_notifications
-from lp.services.features.testing import FeatureFixture
 from lp.testing import TestCaseWithFactory
 
 
@@ -29,9 +28,7 @@
 
     def test_for_bug_modifier_header(self):
         """Test X-Launchpad-Bug-Modifier appears when a bugtask is deleted."""
-        flags = {u"disclosure.delete_bugtask.enabled": u"on"}
-        with FeatureFixture(flags):
-            self.bug_task.delete(self.user)
+        self.bug_task.delete(self.user)
         transaction.commit()
         latest_notification = BugNotification.selectFirst(orderBy='-id')
         notifications, omitted, messages = construct_email_notifications(

=== modified file 'lib/lp/bugs/model/tests/test_bugtask.py'
--- lib/lp/bugs/model/tests/test_bugtask.py	2011-12-20 04:38:42 +0000
+++ lib/lp/bugs/model/tests/test_bugtask.py	2011-12-22 11:40:58 +0000
@@ -23,10 +23,7 @@
     any,
     not_equals,
     )
-from canonical.launchpad.webapp.authorization import (
-    check_permission,
-    clear_cache,
-    )
+from canonical.launchpad.webapp.authorization import check_permission
 from canonical.launchpad.webapp.interfaces import ILaunchBag
 from canonical.testing.layers import (
     AppServerLayer,
@@ -1475,33 +1472,24 @@
 
     layer = DatabaseFunctionalLayer
 
-    flags = {u"disclosure.delete_bugtask.enabled": u"on"}
-
     def test_cannot_delete_if_not_logged_in(self):
         # You cannot delete a bug task if not logged in.
         bug = self.factory.makeBug()
-        with FeatureFixture(self.flags):
-            self.assertFalse(
-                check_permission('launchpad.Delete', bug.default_bugtask))
+        self.assertFalse(
+            check_permission('launchpad.Delete', bug.default_bugtask))
 
     def test_unauthorised_cannot_delete(self):
         # Unauthorised users cannot delete a bug task.
         bug = self.factory.makeBug()
         unauthorised = self.factory.makePerson()
         login_person(unauthorised)
-        with FeatureFixture(self.flags):
-            self.assertFalse(
-                check_permission('launchpad.Delete', bug.default_bugtask))
+        self.assertFalse(
+            check_permission('launchpad.Delete', bug.default_bugtask))
 
     def test_admin_can_delete(self):
         # With the feature flag on, an admin can delete a bug task.
         bug = self.factory.makeBug()
         login_celebrity('admin')
-        with FeatureFixture(self.flags):
-            self.assertTrue(
-                check_permission('launchpad.Admin', bug.default_bugtask))
-        # Admins can also the task even without the feature flag.
-        clear_cache()
         self.assertTrue(
             check_permission('launchpad.Admin', bug.default_bugtask))
 
@@ -1509,12 +1497,7 @@
         # With the feature flag on, the pillar owner can delete a bug task.
         bug = self.factory.makeBug()
         login_person(bug.default_bugtask.pillar.owner)
-        with FeatureFixture(self.flags):
-            self.assertTrue(
-                check_permission('launchpad.Delete', bug.default_bugtask))
-        # They can't delete the task without the feature flag.
-        clear_cache()
-        self.assertFalse(
+        self.assertTrue(
             check_permission('launchpad.Delete', bug.default_bugtask))
 
     def test_bug_supervisor_can_delete(self):
@@ -1523,24 +1506,14 @@
         product = self.factory.makeProduct(bug_supervisor=bug_supervisor)
         bug = self.factory.makeBug(product=product)
         login_person(bug_supervisor)
-        with FeatureFixture(self.flags):
-            self.assertTrue(
-                check_permission('launchpad.Delete', bug.default_bugtask))
-        # They can't delete the task without the feature flag.
-        clear_cache()
-        self.assertFalse(
+        self.assertTrue(
             check_permission('launchpad.Delete', bug.default_bugtask))
 
     def test_task_reporter_can_delete(self):
         # With the feature flag on, the bug task reporter can delete bug task.
         bug = self.factory.makeBug()
         login_person(bug.default_bugtask.owner)
-        with FeatureFixture(self.flags):
-            self.assertTrue(
-                check_permission('launchpad.Delete', bug.default_bugtask))
-        # They can't delete the task without the feature flag.
-        clear_cache()
-        self.assertFalse(
+        self.assertTrue(
             check_permission('launchpad.Delete', bug.default_bugtask))
 
     def test_cannot_delete_only_bugtask(self):
@@ -1548,8 +1521,7 @@
         bug = self.factory.makeBug()
         bugtask = bug.default_bugtask
         login_person(bugtask.owner)
-        with FeatureFixture(self.flags):
-            self.assertRaises(CannotDeleteBugtask, bugtask.delete)
+        self.assertRaises(CannotDeleteBugtask, bugtask.delete)
 
     def test_delete_bugtask(self):
         # A bugtask can be deleted and after deletion, re-nominated.
@@ -1562,8 +1534,7 @@
         nomination = bug.addNomination(bug.owner, target)
         nomination.approve(bug.owner)
         bugtask = bug.getBugTask(target)
-        with FeatureFixture(self.flags):
-            bugtask.delete()
+        bugtask.delete()
         self.assertEqual([bug.default_bugtask], bug.bugtasks)
         self.assertTrue(bug.canBeNominatedFor(target))
 
@@ -1573,8 +1544,7 @@
         bugtask = self.factory.makeBugTask(bug=bug)
         bug = bugtask.bug
         login_person(bug.default_bugtask.owner)
-        with FeatureFixture(self.flags):
-            bug.default_bugtask.delete()
+        bug.default_bugtask.delete()
         self.assertEqual([bugtask], bug.bugtasks)
         self.assertEqual(bugtask, bug.default_bugtask)
 
@@ -1586,8 +1556,7 @@
         login_person(distro.owner)
         dsp_task = bug.addTask(bug.owner, dsp)
         self.assertTrue(dsp.total_bug_heat > 0)
-        with FeatureFixture(self.flags):
-            dsp_task.delete()
+        dsp_task.delete()
         self.assertTrue(dsp.total_bug_heat == 0)
 
 
@@ -2625,24 +2594,23 @@
     layer = AppServerLayer
 
     def test_delete_bugtask(self):
-        """Test that a bugtask can be deleted with the feature flag on."""
+        """Test that a bugtask can be deleted."""
         owner = self.factory.makePerson()
+        some_person = self.factory.makePerson()
         db_bug = self.factory.makeBug()
         db_bugtask = self.factory.makeBugTask(bug=db_bug, owner=owner)
         transaction.commit()
         logout()
 
-        # It will fail without feature flag enabled.
+        # It will fail for an unauthorised user.
+        launchpad = self.factory.makeLaunchpadService(some_person)
+        bugtask = ws_object(launchpad, db_bugtask)
+        self.assertRaises(Unauthorized, bugtask.lp_delete)
+
         launchpad = self.factory.makeLaunchpadService(owner)
         bugtask = ws_object(launchpad, db_bugtask)
-        self.assertRaises(Unauthorized, bugtask.lp_delete)
-
-        flags = {u"disclosure.delete_bugtask.enabled": u"on"}
-        with FeatureFixture(flags):
-            launchpad = self.factory.makeLaunchpadService(owner)
-            bugtask = ws_object(launchpad, db_bugtask)
-            bugtask.lp_delete()
-            transaction.commit()
+        bugtask.lp_delete()
+        transaction.commit()
         # Check the delete really worked.
         with person_logged_in(removeSecurityProxy(db_bug).owner):
             self.assertEqual([db_bug.default_bugtask], db_bug.bugtasks)

=== modified file 'lib/lp/bugs/security.py'
--- lib/lp/bugs/security.py	2011-12-20 23:01:10 +0000
+++ lib/lp/bugs/security.py	2011-12-22 06:03:11 +0000
@@ -27,7 +27,6 @@
 from lp.bugs.interfaces.bugwatch import IBugWatch
 from lp.bugs.interfaces.structuralsubscription import IStructuralSubscription
 from lp.registry.interfaces.role import IHasOwner
-from lp.services.features import getFeatureFlag
 from lp.services.messages.interfaces.message import IMessage
 
 
@@ -62,8 +61,6 @@
         """Check that a user may delete a bugtask.
 
         A user may delete a bugtask if:
-         - The disclosure.delete_bugtask.enabled feature flag is enabled,
-         and they are:
          - project maintainer
          - task creator
          - bug supervisor
@@ -75,11 +72,6 @@
         if user.inTeam(getUtility(ILaunchpadCelebrities).admin):
             return True
 
-        delete_allowed = bool(getFeatureFlag(
-            'disclosure.delete_bugtask.enabled'))
-        if not delete_allowed:
-            return False
-
         bugtask = self.obj
         owner = None
         if IHasOwner.providedBy(bugtask.pillar):

=== modified file 'lib/lp/bugs/tests/test_bugchanges.py'
--- lib/lp/bugs/tests/test_bugchanges.py	2011-10-28 06:49:13 +0000
+++ lib/lp/bugs/tests/test_bugchanges.py	2011-12-22 05:56:59 +0000
@@ -25,7 +25,6 @@
 from lp.bugs.interfaces.cve import ICveSet
 from lp.bugs.model.bugnotification import BugNotification
 from lp.bugs.scripts.bugnotification import construct_email_notifications
-from lp.services.features.testing import FeatureFixture
 from lp.testing import (
     celebrity_logged_in,
     login_person,
@@ -1414,9 +1413,7 @@
         self.saveOldChanges()
 
         login_person(self.user)
-        flags = {u"disclosure.delete_bugtask.enabled": u"on"}
-        with FeatureFixture(flags):
-            task_to_delete.delete()
+        task_to_delete.delete()
 
         task_deleted_activity = {
             'person': self.user,

=== modified file 'lib/lp/services/features/flags.py'
--- lib/lp/services/features/flags.py	2011-12-08 06:33:40 +0000
+++ lib/lp/services/features/flags.py	2011-12-22 05:56:59 +0000
@@ -198,12 +198,6 @@
      '',
      '',
      ''),
-    ('disclosure.delete_bugtask.enabled',
-     'boolean',
-     'Enables bugtasks to be deleted by authorised users.',
-     '',
-     '',
-     ''),
     ('disclosure.allow_multipillar_private_bugs.enabled',
      'boolean',
      'Allows private bugs to have more than one bug task.',

